
module CocoapodsFixModuleUniversal
  def self.place_holder_file_name
    "CocoapodsFixModuleUniversal_placeholder_source.m"
  end

  def self.write_blank_source_to_path(target_dir) # return value ,the relative path to the target_dir
    name = place_holder_file_name
    dir = Pathname.new(target_dir)
    dir.mkpath unless dir.exist?
    file_path = dir + name
    File.write(file_path, "// This file left blank intentionally") unless file_path.exist?
    return name
  end
end


module Pod


  class Installer


    cocoapods_fix_module_universal_old_resolve_dependencies = instance_method(:resolve_dependencies)
    define_method(:resolve_dependencies) do

      # call original
      result = cocoapods_fix_module_universal_old_resolve_dependencies.bind(self).()

      # patch
      # add the blank source to podspec.source_files
      specs = self.analysis_result.specifications.select(&:root?)
      specs.each do |spec|

        original_content = spec.attributes_hash["source_files"]
        if original_content.nil?
          original_content = []
        elsif original_content.kind_of? String
          original_content = [original_content]
        end

        raise "wrong type: #{original_content}" unless original_content.kind_of? Array
        original_content << CocoapodsFixModuleUniversal.place_holder_file_name
        spec.attributes_hash["source_files"] = original_content

      end

      next result
    end



    class PodSourceInstaller

      # add the placeholder .m file
      CocoapodsFixModuleUniversalOLD_install = instance_method :install!
      define_method :install! do |*args|
        result = CocoapodsFixModuleUniversalOLD_install.bind(self).(*args)
        CocoapodsFixModuleUniversal.write_blank_source_to_path(root)
        next result
      end

    end



  end
end
